/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * $Id: contactitem.h,v 1.7 2000/10/14 21:00:50 davidvh Exp $
 */

#ifndef _CONTACTITEM_
#define _CONTACTITEM_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlist.h>
#include "icqmessage.h"
#include "uconfigdb.h"

enum lastEvent {LAST_NONE, LAST_MSG, LAST_URL, LAST_AUTH, LAST_EXCLAM};

class ContactItem
{
protected:
  unsigned long uin;
  QString nick;
  QString alias;
  QString firstName;
  QString lastName;
  QString email;
  unsigned long lastIp; /* Current/Last IP address */
  unsigned long realIp; /* Real IP address */
  unsigned short port;
  unsigned char tcpflag;
  QString city;
  QString state;
  QString zip; /* Where can we get zip code? ;) */
  unsigned short country;
  char countryStat;
  QString homePage;
  unsigned char age;
  QString phone;
  unsigned char gender;
  QString about;
  QString notes;
  unsigned long status;
  unsigned char auth;
  QString historyDir;
  lastEvent msglast;
  bool onlineAlert;
  bool visibleUser;
  bool thruServer;
  QList<icqMessage> messageList;

public:
  // empty contact info for the given UIN
  ContactItem(unsigned long puin);
  // load contact info from the given contact list "Green Line - okidoki" :))) LOL
  ContactItem(unsigned long puin, QString);
  // construct contact info from the given details
  ContactItem(unsigned long puin, QString pnick, QString pfirst, QString plast,
              QString pemail, unsigned char pauth);
  ~ContactItem(void);
  void load(unsigned long, QString);
  void save(void);
  void remove(void);
  QString calcAlias(void) const;
  void addMsg(icqMessage*);
  unsigned long getUIN(void) const { return uin; }
  QString getNick(void) const { return nick; }
  QString getAlias(void) const { return alias; }
  QString getFirstName(void) const { return firstName; }
  QString getLastName(void) const { return lastName; }
  QString getEMail(void) const { return email; }
  unsigned long getLastIP(void) const { return lastIp; }
  unsigned long getRealIP(void) const { return realIp; }
  unsigned short getPort(void) const { return port; }
  unsigned char getTCPFlag(void) const { return tcpflag; }
  QString getCity(void) const { return city; }
  QString getState(void) const { return state; }
  QString getZip(void) const { return zip; }
  unsigned short getCountry(void) const { return country; }
  char getCountryStat(void) const { return countryStat; }
  QString getHomePage(void) const { return homePage; }
  unsigned char getAge(void) const { return age; }
  QString getPhone(void) const { return phone; }
  unsigned char getGender(void) const { return gender; }
  QString getAbout(void) const { return about; }
  QString getNotes(void) const { return notes; }
  unsigned long getStatus(void) const { return status; }
  unsigned char getAuth(void) const { return auth; }
  QString getHistoryDir(void) const { return historyDir; }
  lastEvent getMsgLast(void) const { return msglast; }
  bool isOnlineAlert(void) const { return onlineAlert; }
  bool isVisible(void) const { return visibleUser; }
  bool isThruServer(void) const { return thruServer; }
  QList<icqMessage> *getMsgList(void) { return &messageList; }
  QString getName(void) const;
  void setStatus(unsigned long);
  void setLastIP(unsigned long);
  void setRealIP(unsigned long);
  void setPort(unsigned short);
  void setTCPFlag(unsigned short);
  void setAlias(QString);
  void setNotes(QString);
  void setOnlineAlert(bool);
  void setVisible(bool);
  void setThruServer(bool);
  void updateInfo(QString, QString, QString, QString, char);
  void updateExtInfo(QString, unsigned short, char, QString,
                     unsigned short, char, QString, QString, QString);

  icqMessage *getMsg(int);
  int getNumMsgs(void);
  void setMsgLast(lastEvent);
  icqMsgType getFirstUnreadMsgType(void);
  int getNumUnreadMsgs(void);
private:
  QString bp;
};
#endif
