//
// $Id: icqfilesession.cpp,v 1.1 2001/01/17 01:54:23 bills Exp $
//
// Wrapper class for icqlib's icq_FileSession struct.
//
// $Log: icqfilesession.cpp,v $
// Revision 1.1  2001/01/17 01:54:23  bills
// added
//
// Revision 1.6  2000/11/10 21:14:52  nofate
// admin/* updated from KDE_2_0_STABLE; i18n messages were updated; fixed call
// to icq_Init for icqlib
//
// Revision 1.5  2000/10/14 21:00:50  davidvh
// Minor fixes.
//
// Revision 1.4  2000/09/13 19:11:12  napalmbox
// replase kicq ver 1.0.0 files with kicq ver 2.0.0 files
//
// Revision 1.2.2.2  2000/09/02 21:41:12  napalmbox
// fix fix fix ....a big fix
//
// Revision 1.2.2.1  2000/07/22 19:47:59  napalmbox
// kicq now compiles with -DQT_NO_ASCII_CAST
//
// Revision 1.2  2000/06/17 17:05:27  denis
// Cleanups.
//
// Revision 1.1  2000/05/24 16:57:49  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.1  2000/05/04 16:08:40  bills
// added
//
//



#include "icqfilesession.h"

#include "icqfilesession.moc"

IcqFileSession::IcqFileSession(icq_FileSession *psession)
  : m_session(psession)
{
  return;
}

IcqFileSession::~IcqFileSession(void)
{
  return;
}

void IcqFileSession::fileNotify(int type, int arg, void *data)
{
  if(type == FILE_NOTIFY_STATUS)
    emit statusChanged(arg);
  else if(type == FILE_NOTIFY_DATAPACKET)
    emit progress(currentFileProgress(), totalProgress());
  else if(type == FILE_NOTIFY_CLOSE)
    emit closed();
  else if(type == FILE_NOTIFY_NEW_SPEED)
    emit speedChanged(arg);
  return;
}

void IcqFileSession::setSpeed(int speed)
{
  icq_FileSessionSetSpeed(m_session, speed);
  return;
}

void IcqFileSession::setWorkingDir(const QString &directory)
{
  icq_FileSessionSetWorkingDir(m_session, directory.latin1());
  return;
}

void IcqFileSession::setFiles(const QStrList &files)
{
  // TODO
  return;
}

bool IcqFileSession::isTransferring(void) const
{
  return m_session->status==FILE_STATUS_SENDING || m_session->status==FILE_STATUS_RECEIVING;
}

bool IcqFileSession::isSending(void) const
{
  return m_session->direction==FILE_STATUS_SENDING;
}

bool IcqFileSession::isReceiving(void) const
{
  return m_session->direction==FILE_STATUS_RECEIVING;
}

unsigned long IcqFileSession::remoteUIN(void) const
{
  return m_session->remote_uin;
}

QString IcqFileSession::remoteHandle(void) const
{
  return QString().sprintf("%s", m_session->remote_handle);
}

int IcqFileSession::totalFiles(void) const
{
  return m_session->total_files;
}

int IcqFileSession::currentFileNumber(void) const 
{
  return m_session->current_file_num;
}

unsigned long IcqFileSession::totalSize(void) const
{
  return m_session->total_bytes;
}

unsigned long IcqFileSession::totalProgress(void) const
{
  return m_session->total_transferred_bytes;
}

QString IcqFileSession::workingDir(void) const
{
  return QString().sprintf("%s", m_session->working_dir);
}

QString IcqFileSession::currentFile(void) const 
{
  return QString().sprintf("%s", m_session->current_file);
}

unsigned long IcqFileSession::currentFileSize(void) const 
{
  return m_session->current_file_size;
}

unsigned long IcqFileSession::currentFileProgress(void) const
{
  return m_session->current_file_progress;
}

int IcqFileSession::speed(void) const
{
  return m_session->current_speed;
}

void IcqFileSession::close(void)
{
  icq_FileSessionClose(m_session);
  m_session = NULL;
}
