//
// $Id: icqlibmanager.cpp,v 1.1 2001/02/22 06:01:40 bills Exp $
//
// Base manager class for icqlib sockets & timeouts.  Installs a handler 
// for icq_SocketNotify & icq_SetTimeout, and provides virtual functions 
// installSocketNotifier, removeSocketNotifier, and startTimeout for 
// subclasses to override.
//
// $Log: icqlibmanager.cpp,v $
// Revision 1.1  2001/02/22 06:01:40  bills
// added, supports sockets and timeouts
//
// Revision 1.1  2001/01/27 23:03:45  bills
// Add new socketmanager code, both a generic icqlib wrapper and a KIcq/Qt
// specific
//
//
//

#include <icq.h>

#include "icqlibmanager.h"

IcqlibManager *g_icqlibManager = 0;

IcqlibManager::IcqlibManager()
{
  icq_SocketNotify = onSocketNotify;
  icq_SetTimeout = onSetTimeout;
  g_icqlibManager = this;
}

void IcqlibManager::onSocketNotify(int socket, int type, int status)
{
  if (!g_icqlibManager)
    return;

  if(status)
    g_icqlibManager->installSocketNotifier(socket, type);
  else
    g_icqlibManager->removeSocketNotifier(socket, type);
}

void IcqlibManager::onSetTimeout(long seconds)
{
  if (!g_icqlibManager)
    return;

  g_icqlibManager->startTimeout(seconds);
}
