//
// $Id: sessionmanager.cpp,v 1.1 2001/01/17 01:54:23 bills Exp $
//
// Manager class for IcqChatSession and IcqFileSession objects.  
// Manages lifetime of objects and dispatches notification events
// to proper object.
//
// $Log: sessionmanager.cpp,v $
// Revision 1.1  2001/01/17 01:54:23  bills
// added
//
//

#include "sessionmanager.h"

SessionManager::SessionManager()
{
  chatSessionDict.setAutoDelete(true);
  fileSessionDict.setAutoDelete(false);
}


IcqChatSession *SessionManager::newChatSession(icq_ChatSession *session)
{
	IcqChatSession *pchat = new IcqChatSession(session);
	chatSessionDict.insert(session, pchat);
	
	return pchat;
}

IcqFileSession *SessionManager::newFileSession(icq_FileSession *session)
{
	IcqFileSession *pchat = new IcqFileSession(session);
	fileSessionDict.insert(session, pchat);
	
	return pchat;
}

void SessionManager::handleChatNotification(icq_ChatSession *psession,
	int type, int arg, void *data)
{
	IcqChatSession *p = chatSessionDict[psession];
	
	if (p)
		p->chatNotify(type, arg, data);
	
	if(type == CHAT_NOTIFY_CLOSE)
		chatSessionDict.remove(psession);
}

void SessionManager::handleFileNotification(icq_FileSession *psession,
	int type, int arg, void *data)
{
	IcqFileSession *p = fileSessionDict[psession];
	
	if (p)
		p->fileNotify(type, arg, data);
	
	if(type == FILE_NOTIFY_CLOSE)
		fileSessionDict.remove(psession);
}
