//
// $Id: sessionmanager.h,v 1.1 2001/01/17 01:54:23 bills Exp $
//
// Manager class for IcqChatSession and IcqFileSession objects.  
// Manages lifetime of objects and dispatches notification events
// to proper object.
//
// $Log: sessionmanager.h,v $
// Revision 1.1  2001/01/17 01:54:23  bills
// added
//
//

#ifndef _SESSIONMANAGER_H
#define _SESSIONMANAGER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qptrdict.h>
#include <icq.h>

#include "icqfilesession.h"
#include "icqchatsession.h"

class SessionManager {

public:
  SessionManager();

  IcqChatSession *newChatSession(icq_ChatSession *session);
  IcqFileSession *newFileSession(icq_FileSession *session);
  
  void handleChatNotification(icq_ChatSession *session, int type, int arg, 
    void *data);
  void handleFileNotification(icq_FileSession *session, int type, int arg, 
    void *data);

private:
  QPtrDict<IcqChatSession> chatSessionDict;
  QPtrDict<IcqFileSession> fileSessionDict;

};

#endif // _SESSIONMANAGER_H
