/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _INFOWINDOW_
#define _INFOWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qdialog.h>
#include <qlabel.h>
#include <qtabwidget.h>

#include "contactitem.h"
#include "icqwindow.h"

class MainWidget;
class AddrWidget;
class MoreWidget;
class WorkWidget;
class AboutWidget;

class InfoWindow : public IcqWindow {
  Q_OBJECT
public:
  InfoWindow(unsigned long);
  InfoWindow(ContactItem);
  void setMain(unsigned long, unsigned long, const QString &, const QString &, const QString &, const QString &);
  void setAddr(const QString &, const QString &, const QString &, unsigned short, char, const QString &, const QString &);
  void setMore(const QString &, unsigned int, const QString & );
  void setAbout(const QString &);
  void setNotes(const QString &);
  void setInfo();
  unsigned long getUIN();
  void updateInfo(const QString &, const QString &, const QString &, const QString &, char);
  void updateExtInfo(const QString &, unsigned short, char, const QString &, unsigned short, char,
                     const QString &, const QString &, const QString &);
  void stopCommand();
protected:
  unsigned long uin;
  ContactItem foreignInfo;
  QTabWidget *infotab;
  MainWidget *mainwidget;
  AddrWidget *addrwidget;
  MoreWidget *morewidget;
  WorkWidget *workwidget;
  AboutWidget *aboutwidget;
  QPushButton *donebtn, *updatebtn;
  QLabel *updateanim;
  int local;
  char upd_count;
  void init();
protected slots:
  void doneCommand();
  void updateCommand();
};
#endif
