/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: mainwindow.cpp,v 1.28 2001/05/25 00:54:02 denis Exp $
// Revision 1.74.2.5  2000/07/11 16:36:59  napalmbox
// some add/fixe ...
//
// Revision 1.74.2.4  2000/07/10 11:24:33  napalmbox
// dockwidget use KSystemTray now - work with lates kde2 cvs
//
// Revision 1.74.2.1  2000/07/02 05:45:54  napalmbox
// port kicq -> kde2 :))
//
// Revision 1.74  2000/06/25 18:07:02  denis
// Debug requests from main menu were #ifdef-ed.
// Close contact list and disconnect when going to register new user.
//
// Revision 1.73  2000/06/17 16:49:36  denis
// Whole mainwindow.cpp was splitted for several smaller files:
// mainconfig.cpp, specialops.cpp and, of course, mainwindow.cpp
//
// Revision 1.72  2000/05/24 16:56:34  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.71  2000/05/11 12:15:15  denis
// Actually call icq_Disconnect() on disconnect and close sockets.
//
// Revision 1.70  2000/05/10 19:24:00  denis
// UDP outgoing packet queue was implemented.
// Possible buffer overflow fixed.
// Some cleanups.
//
// Revision 1.69  2000/05/06 18:16:55  denis
// Contact list have been moved to the owner specific location:
//   from ~/.kde/share/apps/kicq/contacts
//   to   ~/.kde/share/apps/kicq/contacts.<UIN>
// Small typo was fixed.
//
// Revision 1.68  2000/05/05 03:39:09  bills
// commented out debug menu item in main icq menu, fixed bug in
// updateBlinking where incorrect icon would be displayed on first blink,
// added correct icon for MSG_FILE_REQ_RECV.
//
// Revision 1.67  2000/05/04 16:13:37  bills
// removed debugging printfs.
//
// Revision 1.66  2000/05/04 15:41:25  denis
// Callbacks moved to the ICQLINK structure.
// Some RegWindow helper code.
//
// Revision 1.65  2000/04/10 14:16:44  denis
// Fixed segfault when some bogus UIN have changed its status.
//
// Revision 1.64  2000/04/04 17:19:23  denis
// Applied patch from Maxim Dmitrichenko <dmax@nix.com.ua> for All/Online
// toggle button with some modifications like transparency in icons and
// save/restore its state in config file.
//
// Revision 1.63  2000/03/30 15:39:34  denis
// Fixed FreeBSD specific compilation error on netinet/in.h header.
//
// Revision 1.62  2000/03/30 15:10:50  denis
// Null password bug fixed.
//
// Revision 1.61  2000/03/01 20:48:29  guruz
// -Added WGet as browser when recieving URLs
// -Modified server prefs
// -fixed some things with special ops
//
// Revision 1.60  2000/01/20 20:03:03  bills
// initial implementation for sending file requests
//
// Revision 1.59  2000/01/10 16:08:44  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.58  1999/12/28 15:56:11  denis
// Reverse IP in Special Options fixed.
//
// Revision 1.57  1999/12/28 01:48:02  bills
// changed tcp timer to 100ms for file transfer, added new code for file transfers
//
// Revision 1.56  1999/12/12 18:08:41  denis
// Existing kapp->topWidget()'s chnaged to MW macros.
//
// Revision 1.55  1999/12/02 15:06:43  denis
// Session management implemented.
// Try to fix Authorization request problems.
// WebPager and EMailExpress messages handlers implemented.
// One big saveConfig() spletted to many specific saveConfig*().
// New egcs compilation warnings fixed.
// Cleanups.
//
// Revision 1.54  1999/11/29 21:24:39  guruz
// Some new features in the user list context menu
// I hope it all REALLY works because i cannot test it
// properly because of the damn online users bug
//
// Revision 1.53  1999/11/21 18:55:35  guruz
// Added "Send E-Mail" in User List Context Menu
//
// Revision 1.52  1999/11/11 15:10:34  guruz
// - Added Base for Webpager Messages. Please type "make fixme"
// - Removed Segfault when kicq is started the first time
//
// Revision 1.51  1999/10/22 17:43:10  guruz
// Password Encryption in kicqrc
//
// Revision 1.50  1999/10/15 16:56:35  guruz
// Various
//
// Revision 1.49  1999/10/14 13:01:45  denis
// Cleanups.
//
// Revision 1.48  1999/10/08 10:38:46  guruz
// Removed some crap i made
//
// Revision 1.47  1999/10/07 18:22:21  denis
// Commented out <linux/kd.h> - it's linux specific.
//
// Revision 1.46  1999/10/06 19:13:32  denis
// Fixed "kicq exit on a new message" bug. LED code is broken.
//
// Revision 1.45  1999/10/05 19:00:35  guruz
// -Added Message Timeout Patch by kyle@13th-floor.org
// -Fixed bug in wrapedit.cpp
//
// Revision 1.44  1999/10/05 14:10:54  guruz
// -Base for a send window that allows to insert predefined phrases
// -Fixed Copy IP To Clipboard
//
// Revision 1.43  1999/10/04 19:15:58  guruz
// -Added "make fixme"
// -The URL Edits are now a bit better
// -The Browser Tab of the Preferences window has another caption
//
// Revision 1.42  1999/10/03 19:07:39  guruz
// There is now the possibility to open URLs that are in the URL Line Edits !
//
// Revision 1.41  1999/10/03 12:13:39  guruz
// Various Changes
//
// Revision 1.40  1999/09/29 17:41:13  denis
// Segmentation fault on startup fixed.
// Markus Goetz <guruz@gmx.de> patches applied.
// kyle@13th-floor.org auto-away patch applied.
//
// Revision 1.39  1999/07/19 13:15:00  tim
// - added support for MSG_ADDED_RECV ("you were added to contact list")
//
// Revision 1.38  1999/07/18 20:29:33  bills
// changed to use new contact list functions
//
// Revision 1.37  1999/07/16 15:48:20  denis
// Cleaned up.
//
// Revision 1.36  1999/07/16 13:26:40  denis
// i18n support added.
//
// Revision 1.35  1999/07/12 15:23:26  cproch
// - changed icq_* function calls and callback function to support
//   icqlib with ICQLINK identifier.
// - look for FIXME in mainwindow.cpp
//
// Revision 1.34  1999/05/04 00:05:46  bills
// added .wav file sound support!
//
// Revision 1.33  1999/04/17 20:24:28  bills
// changed multiple window lists into single window list (except for alert
// windows)
//
// Revision 1.32  1999/04/14 15:36:42  denis
// Cleanups.
//
// Revision 1.31  1999/04/04 22:04:00  bills
// added support for MSG_CHAT_REQ_RECV and chat window handling
//
// Revision 1.30  1999/03/31 01:28:04  bills
// modified userOnline function to include tcpflag
//
// Revision 1.29  1999/03/28 02:00:10  bills
// added tcptimer for icq_TCPMain
//
// Revision 1.28  1999/03/24 11:56:42  denis
// Cleaned up a little
//
// Revision 1.27  1999/03/16 01:09:19  tim
// Cleanup authorize code.
//
// Revision 1.26  1999/03/09 13:17:23  denis
// ICQ Registration Wizard was started
//
// Revision 1.25  1999/03/05 13:04:39  denis
// Applied patch to handle authorization request messages by Bogdan Surdu
// <tim@ima-info.ro>
//
// Revision 1.24  1998/12/11 18:22:01  whale
// Added support for MSG_AUTH_RECV (incoming auth requests)
//
// Revision 1.23  1998/12/08 16:22:58  denis
// getFirstUnreadMsgUIN method added
// setToolTip with updateBlinking methods added
// Reconnect on disconnect preference option added
// Cleaned up a little before releasing
//
// Revision 1.22  1998/11/25 19:17:23  denis
// Hopefully fixed icq_HandleProxyResponse bug
//
// Revision 1.21  1998/11/25 17:47:56  denis
// QSocketNotifier for proxy socket fixed, I hope
// Commented out previous fix

#include <sys/types.h>  // * FreeBSD note: 
#include <sys/socket.h> // * This headers
#include <arpa/inet.h>  // * should be in
#include <netinet/in.h> // * this order.
#include <sys/stat.h>  // for mkdir()
#include <unistd.h>    // for unlink()
#include <stdlib.h>
#include <iostream.h>
#include <icq.h>
#include <qdir.h>
#include <qtimer.h>
#include <qclipboard.h> // for QClipboard::SetText();
#include <qmsgbox.h>
#include <qstrlist.h>
#include <qregexp.h>
#include <kapp.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kwin.h>
#include <khelpmenu.h>
#include <kaboutdialog.h>
#include "mainwindow.h"
#include "xautolock.h"
#include "regwin.h"
#include "chatwindow.h"
#include "kwebbrowser.h"
#include "specialops.h"
#include "userlist.h"
#include "systembar.h"
#include "pref_main.h"
#include "findwindow.h"
#include "infowindow.h"
#include "mydetails.h"
#include "msgwindow.h"
#include "recvwindow.h"
#include "docking.h"
#include "urlsndwin.h"
#include "renwindow.h"
#include "historywin.h"
#include "chatsndwin.h"
#include "filesndwin.h"
#include "icqsound.h"
#include "icqanimbutton.h"
#include "corewidget.h"
#include "filewindow.h"

#include "mainwindow.moc"

#undef DEBUG_REQUEST

MainWindow *MW;

extern "C" char *inet_ntoa(struct in_addr in);

QString MainWindow::intIP2StringIP(unsigned long intIP)
{
  QCString temp;
  char *buf;
  struct in_addr in;
  in.s_addr = ntohl(intIP);
  buf = inet_ntoa(in);
  temp.setStr(buf);
  return temp;
}

MainWindow::MainWindow(void) : KTMainWindow()
{
  CrashGuard();
  MW = this;

  initMainPanel();
  initMainMenus();

  dockwidget = new DockWidget();
  dockwidget->setIcon(UserIcon("coffline"));
  dockwidget->dock();
  connect(dockwidget, SIGNAL(quitClicked()), this, SLOT(quitRequest()));

  blinkPixmap[0] = UserIcon("message");
  blinkPixmap[1] = UserIcon("null");
  blinkFlag = 0;

  connect(kapp, SIGNAL(saveYourself()), this, SLOT(saveSessionConfig()));

  sound = new IcqSound;

  initPreferences();

  startOwner();

  MW->sound->soundEvent("Startup");
  return;
}

MainWindow::~MainWindow(void)
{
  destroyPreferences();
  RemovePointer(sound);
  destroyMainMenus();
  destroyMainPanel();
  RemovePointer(dockwidget);
  MW = 0;
  return;
}

void MainWindow::CrashGuard(void)
{
  MW = 0;
  dockwidget = 0;
  clearMainPanel();
  clearMainMenus();
  sound = 0;
  clearPreferences();
  return;
}

void MainWindow::initPreferences(void)
{
  prefwin = new Preferences();
  prefwin->setDefault();
  if(!checkConfig())
  {
    regwin = new RegWindow(0);
    int retcode = regwin->exec();
    RemovePointer(regwin);
    if(retcode==QDialog::Rejected)
      exit(1);
  }
  icqWinList.setAutoDelete(FALSE);

  findwin = new FindWindow();

  regwin = 0;
  logged = FALSE;
  log_status = stOffline;
  keepalivetimer = -1;
  autoawaytimer = -1;
  return;
}

void MainWindow::destroyPreferences(void)
{
  RemovePointer(findwin);
  RemovePointer(prefwin);
  return;
}

void MainWindow::clearPreferences(void)
{
  prefwin = 0;
  findwin = 0;
  return;
}

void MainWindow::prepareNewUIN(unsigned long u)
{
  setOwnerConfigUIN(u);
  startOwner();
  return;
}

void MainWindow::startOwner(void)
{
  icqStatus st = loadConfig();

  QString spwd = passwd.left(8);

  if(spwd.isNull() | nick.isNull())
  {
    QMessageBox::critical(this, i18n("Fatal Error!, Empty Password or Nick"),
                          i18n("You have not set your Password or your Nick,\n"
                          "please go to Preferences and set your Password and your Nick"));
    return;
  }
  else
    icqlink = icq_ICQLINKNew(uin, spwd.latin1(),nick.latin1(), TRUE );

  setupGUICallbacks();

  setTitle();

  QString yes;
  contactlist.load(yes);

  setStatus(st);

  fillOwnersPopup();
  return;
}

void MainWindow::autoAway(void)
{
  if(!autoawayenabled)
    return;
  int move;
  if(checkTimeOut(move))
  {
    if((cur_status == stOnline) || (cur_status == stFFC))
    {
      setStatus(stAway); // set away
      autoawayset = true;
      initTimeOut(autoawaytimeout * 60); // set auto-away timeout
    }
    else if((cur_status == stAway) && (autoawayset || autoawaytona))
    {
      setStatus(stNA); // set NA
      initTimeOut(autonatimeout * 60); // if away for more than, set NA
    }
  }
  if(move && ((cur_status == stNA) || (cur_status == stAway)) && autoawayset)
  {
    setStatus(stOnline); // set online
    autoawayset = false;
    initTimeOut(autoawaytimeout * 60); // set auto-away timeout
  }
  return;
}

void MainWindow::setTitle(void)
{
  QString title;
  title.setNum(uin);
  setCaption(title);
  return;
}

void MainWindow::closeEvent(QCloseEvent*)
{
  dockwidget->hideWindow();
  return;
}

void MainWindow::quitRequest(void)
{
  saveProperties();
  saveStatus();
  setStatus(stOffline);
  kapp->quit();
  return;
}

void MainWindow::recvRequest(void)
{
  if(listwidget->currentItem()>=0)
    recvRequest(listwidget->currentItem());
  return;
}

void MainWindow::recvRequest(int num)
{
  UserItem *usritem = listwidget->getItem(num);
  if(!usritem->canBeSelected())
    return;

  /* If we have any new messages here, we must show them */
  /* otherwise display new message window */
  if(contactList().getNumUnreadMsgsByUIN(usritem->getUIN()))
  {
    RecvWindow *recvwin = 0;
    IcqWindow *ptr;
    for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
    { 
      if(ptr->inherits("RecvWindow"))
      {
        RecvWindow *precv=(RecvWindow*)ptr;
        if(precv->UIN() == usritem->getUIN())
          recvwin = precv;
      }
    }
    if(!recvwin)
    {
      QList<icqMessage> *l = contactList().getMsgListByUIN(usritem->getUIN());
      recvwin =
        new RecvWindow(l, l->count() - contactList().getNumUnreadMsgsByUIN(usritem->getUIN()),
                       usritem->getUIN(),TRUE);
      recvwin->show();
    }
    else
      recvwin->raise();
  }
  else
    messageRequest(num);
  return;
}

void MainWindow::messageRequest(void)
{
  if(listwidget->currentItem() >= 0)
    messageRequest(listwidget->currentItem());
  return;
}

void MainWindow::messageRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
// FIXME: Possible memory leak.
  MsgWindow *msgwin = new MsgWindow(contactList().getNickByUIN(uin), uin,
                                    contactList().getEMailByUIN(uin), 0);
  msgwin->show();
  return;
}

void MainWindow::messageRequest(unsigned long uin, const QString &msg)
{
  const ContactItem *item = contactList().getInfoByUIN(uin);
  if(item)
  {
// FIXME: Possible memory leak.
    MsgWindow *msgwin = new MsgWindow(item->getNick(), item->getUIN(), item->getEMail(), msg);
    msgwin->show();
  }
  return;
}

void MainWindow::chatRequest(void)
{
  if(listwidget->currentItem()>=0)
    chatRequest(listwidget->currentItem());
  return;
}

void MainWindow::chatRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
// FIXME: Possible memory leak.
  ChatSndWindow *chatwin = new ChatSndWindow(contactList().getNickByUIN(uin), uin,
                                             contactList().getEMailByUIN(uin));
  chatwin->show();
  return;
}

void MainWindow::fileRequest(void)
{
  if(listwidget->currentItem() >= 0)
    fileRequest(listwidget->currentItem());
  return;
}

void MainWindow::fileRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
// FIXME: Possible memory leak.
  FileSndWindow *filewin = new FileSndWindow(contactList().getNickByUIN(uin), uin,
                                             contactList().getEMailByUIN(uin));
  filewin->show();
  return;
}

void MainWindow::urlRequest(void)
{
  if(listwidget->currentItem() >= 0)
    urlRequest(listwidget->currentItem());
  return;
}

void MainWindow::urlRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
// FIXME: Possible memory leak.
  URLSndWindow *urlwin = new URLSndWindow(contactList().getNickByUIN(uin), uin,
                                          contactList().getEMailByUIN(uin));
  urlwin->show();
  return;
}

void MainWindow::authRequest(void)
{
  if(listwidget->currentItem() >= 0)
    authRequest(listwidget->currentItem());
  return;
}

void MainWindow::authRequest(int num)
{
  icq_SendAuthMsg(icqlink, listwidget->getItem(num)->getUIN());
  return;
}

void MainWindow::historyRequest(void)
{
  if(listwidget->currentItem() >= 0)
    historyRequest(listwidget->currentItem());
  return;
}

void MainWindow::historyRequest(int num)
{
  unsigned long uin = listwidget->getItem(num)->getUIN();
// FIXME: Possible memory leak.
  HistoryWindow *hwin = new HistoryWindow(uin);
  hwin->show();
  return;
}

void MainWindow::readFirstRequest(void)
{
  unsigned int i;
  for(i=0; i<listwidget->count(); i++)
  {
    UserItem *ptr = listwidget->getItem(i);
    if(ptr->canBeSelected())
      if(contactList().getNumUnreadMsgsByUIN(ptr->getUIN()))
      {
        recvRequest(i);
        return;
      }
  }
  return;
}

void MainWindow::addCommand(void)
{
  findwin->show();
  findwin->raise();
  return;
}

void MainWindow::setAllOnline(bool allSet)
{
  listwidget->setAllOnline(allSet);
  if(listwidget->getAllOnline())
  {
    allbutton->setIconSet(UserIcon("all"));
    allbutton->setOn(FALSE);
  }
  else
  {
    allbutton->setIconSet(UserIcon("notall"));
    allbutton->setOn(TRUE);
  }
  allbutton->update();
  return;
}

bool MainWindow::getAllOnline(void)
{
  return listwidget->getAllOnline();
}

void MainWindow::allCommand(void)
{
  listwidget->allChange();
  setAllOnline(getAllOnline());
  updateVisibleList();
  return;
}

void MainWindow::registerCommand(void)
{
  setStatus(stOffline);
  dockwidget->hideWindow();
  regwin = new RegWindow(0);
  regwin->exec();
  RemovePointer(regwin);
  return;
}

void MainWindow::userOnline(ICQLINK *link, unsigned long uin, unsigned long status,
                            unsigned long ip, unsigned short port, unsigned long r_ip,
                            unsigned char tcp_flag)
{
  (void)link;
  if(MW->contactList().isUINInContactList(uin))
  {
    MW->contactList().userOnlineByUIN(uin, status, ip, port, r_ip, tcp_flag);
    if(MW->contactList().getOnlineAlertByUIN(uin))
      MW->addAlertWin(uin);
  }
  return;
}

void MainWindow::userStatusUpdate(ICQLINK *link, unsigned long uin, unsigned long status)
{
  (void)link;
  MW->contactList().setStatusByUIN(uin, status);
  return;
}

void MainWindow::userOffline(ICQLINK *link, unsigned long uin)
{
  (void)link;
  MW->contactList().setStatusByUIN(uin, (unsigned long)STATUS_OFFLINE);
  return;
}

void MainWindow::infoRequest(void)
{
  if(listwidget->currentItem() >= 0)
    infoWindow(listwidget->getCurrent()->getUIN());
  return;
}

void MainWindow::infoWindow(unsigned long uin)
{
  QString usern = i18n("User Details For: ");
  usern += MW->contactList().getNickByUIN(uin);
  InfoWindow *infowin = 0;

  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *pinfo=(InfoWindow*)ptr;
      if(pinfo->getUIN() == uin)
        infowin = pinfo;
    }
  }
// FIXME: Possible memory leak.
  if(!infowin)
    infowin = new InfoWindow(uin);
  infowin->show();
  infowin->raise();
  infowin->setCaption(usern);
  return;
}

void MainWindow::infoWindow(ContactItem info)
{
  InfoWindow *infowin = 0;

  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *pinfo=(InfoWindow*)ptr;
      if(pinfo->getUIN() == info.getUIN())
        infowin = pinfo;
    }
  }
// FIXME: Possible memory leak.
  if(!infowin)
    infowin = new InfoWindow(info);
  infowin->show();
  infowin->raise();
  return;
}

void MainWindow::onlineAlert(void)
{
  if(listwidget->currentItem() < 0)
    return;
  contactList().toggleOnlineAlertByUIN(listwidget->getCurrent()->getUIN());
  updateVisibleList();
  return;
}

void MainWindow::visibleUser(void)
{
  if(listwidget->currentItem() < 0)
    return;
  contactList().toggleVisibleUserByUIN(listwidget->getCurrent()->getUIN());
  if(logged)
    icq_SendVisibleList(icqlink);
  updateVisibleList();
  return;
}

void MainWindow::renameRequest(void)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long uin = listwidget->getCurrent()->getUIN();

  if(!contactList().isUINInContactList(uin))
    return;
  RenameWindow *renwin = 0;

  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("RenameWindow"))
    {
      RenameWindow *pren=(RenameWindow*)ptr;
      if(pren->UIN() == uin)
        renwin = pren;
    }
  }
  if(renwin)
  {
    renwin->raise();
    return;
  }
  const ContactItem *item = contactList().getInfoByUIN(uin);
  if(!item)
    return;
// FIXME: Possible memory leak.
  renwin = new RenameWindow(item->getName(), uin, item->getNick(), item->getFirstName(),
                            item->getLastName(), item->getEMail());
  renwin->show();
  return;
}

void MainWindow::delUserRequest(void)
{
  if(listwidget->currentItem() < 0)
    return;
  UserItem *usritem = listwidget->getCurrent();
  QString tmp;
  unsigned long uin = usritem->getUIN();
  tmp.sprintf("Are you sure you want to delete\nuser %s with ICQ# %lu?", contactList().getNickByUIN(uin).latin1(), uin);
  if(QMessageBox::warning(this, i18n("Confirm"), tmp, QMessageBox::Yes,
                          QMessageBox::No | QMessageBox::Default |
                          QMessageBox::Escape) != QMessageBox::Yes)
    return;
  if(usritem->isBlinking())
    listwidget->setBlinkingByUIN(uin, FALSE);

  if(contactList().isUINNotInList(uin))
    contactList().deleteNILByUIN(uin);
  else
    contactList().deleteByUIN(uin);
  updateVisibleList();
  return;
}

void MainWindow::setOnlineStatus(icqStatus kst, unsigned long lst)
{
  if(logged == TRUE)
  {
    statebutton->setStatus(kst);
    icq_ChangeStatus(icqlink, lst);
    cur_status = kst;
  }
  else
  {
    statebutton->setStatus(stLogin);
    if(useproxy)
      icq_SetProxy(icqlink, proxyhost.latin1(), proxyport, proxyauth, proxyuser.latin1(), proxypass.latin1());
    else
      icq_UnsetProxy(icqlink);
    if(icq_Connect(icqlink, server.latin1(), port) != -1)
    {
      login(lst);
      log_status = kst;
    }
    else
      statebutton->setStatus(stOffline);
  }
  return;
}

void MainWindow::setStatus(int status)
{
  switch(status)
  {
    case stOffline:
      if(logged)
      {
        logged = FALSE;
        icq_Logout(icqlink);
      }
      statebutton->setStatus(stOffline);
      cur_status = stOffline;
      contactList().setAllOffline();
      disconnect();
      break;
    case stOnline:
      setOnlineStatus(stOnline, STATUS_ONLINE);
      break;
    case stAway:
      setOnlineStatus(stAway, STATUS_AWAY);
      break;
    case stDND:
      setOnlineStatus(stDND, STATUS_DND);
      break;
    case stNA:
      setOnlineStatus(stNA, STATUS_NA);
      break;
    case stOccupied:
      setOnlineStatus(stOccupied, STATUS_OCCUPIED);
      break;
    case stInvisible:
      setOnlineStatus(stInvisible, STATUS_INVISIBLE);
      break;
    case stFFC:
      setOnlineStatus(stFFC, STATUS_FREE_CHAT);
      break;
    default:
      statebutton->setStatus((icqStatus)status);
      cur_status = (icqStatus)status;
      break;
  }
  setToolTip();
  return;
}

void MainWindow::setLogStatus(void)
{
  setStatus(log_status);
  return;
}

icqStatus MainWindow::status(void)
{
  return cur_status;
}

void MainWindow::login(unsigned long status)
{
  icq_Login(icqlink, status);
  if(keepalivetimer == -1)
    keepalivetimer = startTimer(120000);
  if(autoawaytimer == -1)
    autoawaytimer = startTimer(5000);
  autoawayset = false;
  initTimeOut(autoawaytimeout * 60); // set auto-away timeout
  return;
}

void MainWindow::disconnect(void)
{
  autoawayset = false;
  freeTimeOut(); // clear auto-away timeout
  stopAll();
  icq_Disconnect(icqlink);
  killTimer(keepalivetimer);
  keepalivetimer = -1;
  killTimer(autoawaytimer);
  autoawaytimer = -1;
  return;
}

void MainWindow::setupGUICallbacks(void)
{
  icqlink->icq_Logged = loggedIn;
  icqlink->icq_Disconnected = disconnected;
  icqlink->icq_UserOnline = userOnline;
  icqlink->icq_UserOffline = userOffline;
  icqlink->icq_UserStatusUpdate = userStatusUpdate;
  icqlink->icq_RecvMessage = message;
  icqlink->icq_RecvURL = url;
  icqlink->icq_RecvWebPager = webPager;
  icqlink->icq_RecvMailExpress = mailExpress;
  icqlink->icq_InfoReply = infoReply;
  icqlink->icq_ExtInfoReply = infoExtReply;
  icqlink->icq_Log = logEvent;
  icqlink->icq_RecvAuthReq = authreq;
  icqlink->icq_RecvChatReq = chatReq;
  icqlink->icq_RecvFileReq = fileReq;
  icqlink->icq_RequestNotify = requestNotify;
  icqlink->icq_FileNotify = fileNotify;
  icqlink->icq_ChatNotify = chatNotify;
  icqlink->icq_RecvAdded = added;
  icqlink->icq_MetaUserInfo = metaUserInfo;
  icqlink->icq_MetaUserWork = metaUserWork;
  icqlink->icq_MetaUserMore = metaUserMore;
  icqlink->icq_MetaUserAbout = metaUserAbout;
  icqlink->icq_MetaUserInterests = metaUserInterests;
  icqlink->icq_MetaUserAffiliations = metaUserAffiliations;
  icqlink->icq_MetaUserHomePageCategory = metaUserHomePageCategory;
  return;
}

void MainWindow::logEvent(ICQLINK *link, time_t time, unsigned char level, const char *str)
{
  char lvl[4][4] = {"fat", "err", "wrn", "msg"};
  int std = FALSE;
  FILE *log;
  struct tm *log_time;
  (void)link;
  log = fopen(MW->logFile().latin1(), "a");
  if(!log)
  {
    log = fdopen(1, "w");
    std = TRUE;
  }
  log_time = localtime(&time);
  fprintf(log, "%02i/%02i/%04i %02i:%02i:%02i [%s] %s", log_time->tm_mday, log_time->tm_mon+1,
          log_time->tm_year+1900, log_time->tm_hour, log_time->tm_min, log_time->tm_sec,
          lvl[level-1], str);
  if(!std)
    fclose(log);
  return;
}

void MainWindow::loggedIn(ICQLINK *link)
{
  (void)link;
  MW->logged = TRUE;
  MW->setLogStatus();
  return;
}

void MainWindow::disconnected(ICQLINK *link)
{
  (void)link;
  icqStatus status = MW->status();
  MW->logged = FALSE;
  MW->disconnect();
  MW->setStatus(stOffline);
  if(MW->reconnect)
    MW->setStatus(status);
  return;
}

void MainWindow::stopAll(void)
{
 // findwin->stopCommand();
  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("InfoWindow"))
      ((InfoWindow*)ptr)->stopCommand();
    if(ptr->inherits("MsgWindow"))
      ((MsgWindow*)ptr)->stopCommand();
    if(ptr->inherits("URLSndWindow"))
      ((URLSndWindow*)ptr)->stopCommand();
  }
  return;
}

void MainWindow::requestNotify(ICQLINK *link, unsigned long id, int type, int length, void *data)
{
  (void)link;
  MW->doNotify(id,type,length,data);
  return;
}

void MainWindow::chatNotify(icq_ChatSession *psession, int type, int arg,
  void *data)
{
  MW->doChatNotify(psession, type, arg, data);
  return;
}

void MainWindow::fileNotify(icq_FileSession *psession, int type, int arg,
  void *data)
{
  MW->doFileNotify(psession, type, arg, data);
  return;
}

void MainWindow::doChatNotify(icq_ChatSession *psession, int type, int arg,
  void *data)
{
  sessionManager.handleChatNotification(psession, type, arg, data);
}

void MainWindow::doFileNotify(icq_FileSession *psession, int type, int arg,
  void *data)
{
  sessionManager.handleFileNotification(psession, type, arg, data);    
}

void MainWindow::doNotify(unsigned long id, int type, unsigned int length, void *data)
{
  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->seq() == id)
      ptr->requestNotify(type, length, data);
  }

  if(type == ICQ_NOTIFY_CHATSESSION)
  {
    IcqChatSession *pchat = 
      sessionManager.newChatSession((icq_ChatSession *)data);

    ChatWindow *p = new ChatWindow(pchat);
    p->show();
  }

  if(type == ICQ_NOTIFY_FILESESSION)
  {
    IcqFileSession *pchat =
      sessionManager.newFileSession((icq_FileSession *)data);

    FileWindow *p = new FileWindow(pchat);
    p->show();
  }

  return;
}

void MainWindow::timerEvent(QTimerEvent *te)
{
  if(te->timerId() == keepalivetimer)
    icq_KeepAlive(icqlink);
  else if(te->timerId() == autoawaytimer)
    autoAway();
  return;
}

void MainWindow::updateVisibleList(void)
{
  if(listwidget)
    listwidget->changeList();
  return;
}

void MainWindow::addAlertWin(unsigned long uin)
{
  AlertMsgBox *win = 0, *ptr;
  QString text;

  for(ptr = alertWinList.first(); ptr; ptr = alertWinList.next())
    if(ptr->inherits("AlertMsgBox"))
    {
      AlertMsgBox *box=(AlertMsgBox*)ptr;
      if(box->uin() == uin)
      {
        box->raise();
        return;
      }
    }
  time_t tmsec = time(0);
  struct tm *tmstr = localtime(&tmsec);
  text.sprintf("User %s is online\n%02i:%02i:%02i %02i/%02i/%04i",
               contactList().getNameByUIN(uin).latin1(), tmstr->tm_hour, tmstr->tm_min,
               tmstr->tm_sec, tmstr->tm_mon+1, tmstr->tm_mday, tmstr->tm_year+1900);
// FIXME: Possible memory leak.
  win = new AlertMsgBox(uin, i18n("Online Alert"), text);
  alertWinList.append(win);
  win->show();

  MW->sound->soundEvent("Online Alert");
  return;
}

void MainWindow::delAlertWin(AlertMsgBox *win)
{
  alertWinList.removeRef(win);
  return;
}

void MainWindow::updateRecvWindows(void)
{
  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("RecvWindow"))
    {
      RecvWindow *box=(RecvWindow*)ptr;
      box->updateNextAvailability();
    }
  }

  return;
}

void MainWindow::setIcon(QPixmap icon)
{
  stateIcon = icon;
  if(!blinkFlag && dockwidget)
    dockwidget->setIcon(stateIcon);
  return;
}

void MainWindow::setBlinking(int flag)
{
  blinkFlag = flag;
  if(blinkFlag)
    togglePixmap(0);
  else
    setIcon(stateIcon);
  return;
}

void MainWindow::togglePixmap(int num)
{
  dockwidget->setIcon(blinkPixmap[num]);
  setKeyboardLED((num == 0) ? TRUE : FALSE);
  return;
}

int MainWindow::isUnreadMsgs(void)
{
  return (getFirstUnreadMsgUIN() != 0);
}

unsigned long MainWindow::getFirstUnreadMsgUIN()
{
  for(unsigned int i = 0; i < listwidget->count(); i++)
  {
    UserItem *ptr = listwidget->getItem(i);
    if(ptr->canBeSelected())
      if(contactList().getNumUnreadMsgsByUIN(ptr->getUIN()))
        return ptr->getUIN();
  }
  return 0;
}

void MainWindow::updateHistoryWindows(unsigned long uin)
{
  IcqWindow *ptr;
  for( ptr = icqWinList.first(); ptr; ptr = icqWinList.next() )
  { 
    if(ptr->inherits("HistoryWindow"))
    {
      HistoryWindow *win=(HistoryWindow*)ptr;
      if(win->UIN() == uin)
        win->refresh();
    }
  }
  return;
}

void MainWindow::setBlinkPixmap(const QString &p)
{
  blinkPixmap[0] = UserIcon(p);
  return;
}

void MainWindow::setToolTip(void)
{
  QString text;
  if(isUnreadMsgs())
  {
    unsigned long u = getFirstUnreadMsgUIN();
    if(u)
    {
      switch(contactList().getFirstUnreadMsgTypeByUIN(u))
      {
        case MSG_SENT:
        case MSG_RECV:
          text = i18n("Message from ");
          break;
        case MSG_URL_SENT:
        case MSG_URL_RECV:
          text = i18n("URL from ");
          break;
        case MSG_AUTH_RECV:
          text = i18n("Authorization request from ");
          break;
        default:
          text = i18n("Event from ");
          break;
      }
      text += contactList().getNameByUIN(u);
    }
  }
  else
  {
    switch(cur_status)
    {
      case stLogin:
        text = i18n("Connecting");
        break;
      case stOffline:
        text = i18n("Offline");
        break;
      case stOnline:
        text = i18n("Online");
        break;
      case stAway:
        text = i18n("Away");
        break;
      case stNA:
        text = i18n("Not Available");
        break;
      case stDND:
        text = i18n("Do not Disturb");
        break;
      case stOccupied:
        text = i18n("Occupied");
        break;
      case stInvisible:
        text = i18n("Invisible");
        break;
      case stFFC:
        text = i18n("Free for Chat");
        break;
    }
  }
  dockwidget->setToolTip(text);
  return;
}

void MainWindow::updateBlinking(void)
{
  if(isUnreadMsgs())
  {
    unsigned long u = getFirstUnreadMsgUIN();
    if(u)
      switch(contactList().getFirstUnreadMsgTypeByUIN(u))
      {
        case MSG_SENT:
        case MSG_RECV:
          setBlinkPixmap("message");
          break;
        case MSG_URL_SENT:
        case MSG_URL_RECV:
          setBlinkPixmap("url");
          break;
        case MSG_AUTH_RECV:
          setBlinkPixmap("auth");
          break;
        case MSG_CHAT_REQ_RECV:
          setBlinkPixmap("chat");
          break;
        case MSG_FILE_REQ_RECV:
          setBlinkPixmap("file");
          break;
        case MSG_ADDED:
          setBlinkPixmap("exclam");
          break;
        default:
          setBlinkPixmap("null");
          break;
      }
  }
  setToolTip();
  int a = listwidget->blinkItemsCount();
  setBlinking((a) ? TRUE : FALSE);
}

void MainWindow::addIcqWindow(IcqWindow *win)
{
  icqWinList.append(win);
  return;
}

void MainWindow::delIcqWindow(IcqWindow *win)
{
  icqWinList.removeRef(win);
  return;
}

// FIXME: The following code is coming soon!
void MainWindow::setKeyboardLED(bool on)
{
  (void)on;
  return;
}

void MainWindow::slotHelpAbout(void)
{
  KAboutDialog *adlg = new KAboutDialog(KAboutDialog::AbtProduct | KAboutDialog::AbtTitle |
                                        KAboutDialog::AbtImageOnly, kapp->caption(),
                                        KDialogBase::Ok, KDialogBase::Ok, this, 0, true);
  adlg->setTitle(kapp->caption());
  adlg->setProduct("", "2.0.0", "kicq team", "(C)2000");
  adlg->setImage(locate("kicq_pics", "aboutkicq_logo.png"));
  adlg->exec();
  RemovePointer(adlg);
  return;
}

void MainWindow::fillOwnersPopup(void)
{
  QString ownstr, uinstr, itemstr;
  ownstr.setNum(getOwnerConfigUIN());
  ownersmenu->clear();
  ownersmenu->setCheckable(TRUE);
  ownersmenu->setMouseTracking(TRUE);
  connect(ownersmenu, SIGNAL(activated(int)), SLOT(changeOwner(int)));

  db->setPath("/Owners");
  UCPathIterator it( db );
  for(Q_UINT32 id=0; it; ++it) {
    uinstr=it.group();
    if(uinstr=="0")
      continue;
    db->setPath("/Owners/" + uinstr + "/Main");
    db->readEntry("Nick", itemstr);
    if(itemstr.isEmpty())
      itemstr = uinstr;
    else
      itemstr += " (" + uinstr + ')';
    ownersmenu->insertItem(itemstr, id);
    ownersmenu->setItemChecked(id, uinstr==ownstr);
    ++id;
  }
  return;
}

void MainWindow::changeOwner(int id)
{
  unsigned long newUIN;
  QString OwnerName;
  OwnerName = ownersmenu->text(id);
  newUIN = parseUIN(OwnerName);
  if(newUIN == uin)
    return;
  findwin->clearCommand();
  saveSessionConfig();
  setStatus(stOffline);
  icq_ICQLINKDelete(icqlink);
  prepareNewUIN(newUIN);
}

unsigned long int MainWindow::parseUIN(QString &OwnerStr)
{
  QString OwnerName = OwnerStr;
  unsigned long int OwnerUIN;
  if(OwnerName.findRev('(') != -1) {
    OwnerName.truncate(OwnerName.findRev('(') - 1);
    OwnerStr = OwnerStr.right(OwnerStr.findRev(')') - OwnerStr.findRev('('));
    OwnerStr.truncate(OwnerStr.length() - 1);
  }
  OwnerUIN = OwnerStr.toULong();
  OwnerStr = OwnerName;
  return OwnerUIN;
}

void MainWindow::homepage(void)
{
  if(listwidget->currentItem() >= 0)
  {
    unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
    if(ip)
      webBrowserRequest(-1, "http://");
    else
      QMessageBox::warning(this, i18n("Error"), i18n("Cannot determinate IP of this user!"));
  }
  return;
}

void MainWindow::myDetails(void)
{
  QString s = i18n("Details For Owner: ");
  s += nick;
  myinfowin = new MyInfoWin();
  myinfowin->setCaption(s);
  myinfowin->setMainWidgetUIN(QString::number(uin), nick);
  myinfowin->setMainWidgetNames(i18n(""), i18n(""));
  myinfowin->show();
  return;
}
