/***************************************************************************
    description          : metauserinfo.cpp
    begin                : Thu Sep 14 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "mainwindow.h"
#include "infowindow.h"

void MainWindow::infoReply(ICQLINK *link, unsigned long uin, const char *nick, const char *first,
                           const char *last, const char *email, char auth)
{
  MW->infoReplyHandler(uin, nick, first, last, email, auth);
  return;
}

void MainWindow::infoExtReply(ICQLINK *link, unsigned long uin, const char *city,
                              unsigned short country_code, char country_stat, const char *state,
                              unsigned short age, char gender, const char *phone, const char *hp, const char *about)
{
  MW->infoExtReplyHandler(uin, city, country_code, country_stat, state, age, gender, phone, hp, about);
  return;
}

void MainWindow::infoReplyHandler(unsigned long uin, const QString &nick, const QString &first,
                                  const QString &last, const QString &email, char auth)
{
  IcqWindow *ptr;

  for(ptr = icqWinList.first(); ptr ; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *iptr=(InfoWindow*)ptr;
      if(iptr->getUIN() == uin)
        iptr->updateInfo(nick, first, last, email, auth);
    }
  }
  MW->contactList().updateInfoByUIN(uin, nick, first, last, email, auth);
  return;
}

void MainWindow::infoExtReplyHandler(unsigned long uin, const QString &city, Q_UINT16 country_code,
                                     char country_stat, const QString &state, Q_UINT16 age,
                                     char gender, const QString &phone, const QString &hp, const QString &about)
{
  IcqWindow *ptr;
  for(ptr = icqWinList.first(); ptr ; ptr = icqWinList.next())
  {
    if(ptr->inherits("InfoWindow"))
    {
      InfoWindow *iptr=(InfoWindow*)ptr;
      if(iptr->getUIN() == uin)
        iptr->updateExtInfo(city, country_code, country_stat, state, age,gender, phone, hp, about);
    }
  }
  return;
}

void MainWindow::metaUserInfo(ICQLINK *link, unsigned short seq2, const char *nick,
                           const char *first, const char *last, const char *pri_eml,
                           const char *sec_eml, const char *old_eml, const char *city,
                           const char *state, const char *phone, const char *fax,
                           const char *street, const char *cellular, unsigned long zip,
                           unsigned short country, unsigned char timezone, unsigned char auth,
                           unsigned char webaware, unsigned char hideip)
{
  return;
}

void MainWindow::metaUserWork(ICQLINK *link, unsigned short seq2, const char *wcity,
                           const char *wstate, const char *wphone, const char *wfax,
                           const char *waddress, unsigned long wzip, unsigned short wcountry,
                           const char *company, const char *department, const char *job,
                           unsigned short occupation, const char *whomepage)
{
  return;
}

void MainWindow::metaUserMore(ICQLINK *link, unsigned short seq2, unsigned short age,
                           unsigned char gender, const char *homepage, unsigned char byear,
                           unsigned char bmonth, unsigned char bday, unsigned char lang1,
                           unsigned char lang2, unsigned char lang3)
{
  return;
}

void MainWindow::metaUserAbout(ICQLINK *link, unsigned short seq2, const char *about)
{
  return;
}

void MainWindow::metaUserInterests(ICQLINK *link, unsigned short seq2, unsigned char num,
                                unsigned short icat1, const char *int1, unsigned short icat2,
                                const char *int2, unsigned short icat3, const char *int3,
                                unsigned short icat4, const char *int4)
{
  return;
}

void MainWindow::metaUserAffiliations(ICQLINK *link, unsigned short seq2, unsigned char anum,
                                   unsigned short acat1, const char *aff1, unsigned short acat2,
                                   const char *aff2, unsigned short acat3, const char *aff3,
                                   unsigned short acat4, const char *aff4, unsigned char bnum,
                                   unsigned short bcat1, const char *back1, unsigned short bcat2,
                                   const char *back2, unsigned short bcat3, const char *back3,
                                   unsigned short bcat4, const char *back4)
{
  return;
}

void MainWindow::metaUserHomePageCategory(ICQLINK *link,unsigned short seq2, unsigned char num,
                                       unsigned short hcat1, const char *htext1)
{
  return;
}
