/***************************************************************************
    description          : msgevents.cpp
    begin                : Thu Sep 14 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "icqsound.h"
#include "mainwindow.h"

void MainWindow::message(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *data)
{
  MW->sound->soundEvent("Incoming Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addMsg(uin,time,data);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::url(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                     unsigned char day, unsigned char month, unsigned short year, const char *url,
                     const char *desc)
{
  MW->sound->soundEvent("Incoming URL");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addURL(uin,time,url,desc);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::chatReq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *desc,
                         unsigned long seq)
{
  MW->sound->soundEvent("Chat Request");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addChatReq(uin,time,desc,seq);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::webPager(ICQLINK *link, unsigned char hour, unsigned char minute,
                          unsigned char day, unsigned char month, unsigned short year,
                          const char *nick, const char *email, const char *msg)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour, minute, day, month, year);
  MW->contactList().addPager(0, time, nick, email, msg);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::mailExpress(ICQLINK *link, unsigned char hour, unsigned char minute,
                             unsigned char day, unsigned char month, unsigned short year,
                             const char *nick, const char *email, const char *msg)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour, minute, day, month, year);
  MW->contactList().addExpress(0, time, nick, email, msg);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::fileReq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *desc,
                         const char *file, unsigned long size, unsigned long seq)
{
  MW->sound->soundEvent("File Request");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addFileReq(uin,time,desc, file, size, seq);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}


void MainWindow::authreq(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                         unsigned char day, unsigned char month, unsigned short year, const char *nick,
                         const char *first, const char *last, const char *email, const char *reason)
{
  MW->sound->soundEvent("Authorization Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addAuth(uin,time,nick,first,last,email,reason);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

void MainWindow::added(ICQLINK *link, unsigned long uin, unsigned char hour, unsigned char minute,
                       unsigned char day, unsigned char month, unsigned short year, const char *nick,
                       const char *first, const char *last, const char *email)
{
  MW->sound->soundEvent("System Message");

  TimeStr time(hour,minute,day,month,year);
  MW->contactList().addAdded(uin,time,nick,first,last,email);
  MW->updateRecvWindows();
  MW->updateBlinking();
  return;
}

