/***************************************************************************
    description          : recvwindow.h
    begin                : Wed Apr 12 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _RECVWINDOW_H_
#define _RECVWINDOW_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <time.h>
#include <qpushbt.h>
#include <qgrpbox.h>
#include <qlabel.h>
#include <qmlined.h>
#include <qlined.h>
#include <qwidgetstack.h>
#include <qlayout.h>
#include <qframe.h>
#include "icqwindow.h"
#include "icqmessage.h"

#include "main.h"


class KURLLineEdit;

class RecvDetail : public QWidget {
  Q_OBJECT
public:
  RecvDetail(icqMessage *msg, QWidget *parent = 0);
  QLabel *frame;
  icqMessage *message;
protected slots:
  void addRequest();
};

class RecvMessage : public RecvDetail {
  Q_OBJECT
public:
  RecvMessage(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void replyRequest();
private:
  QMultiLineEdit *msgedit;
  QGroupBox *aBox;
};

class RecvURL : public RecvDetail {
  Q_OBJECT
public:
  RecvURL(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void replyRequest();
private:
  QMultiLineEdit *urldesc;
  KURLLineEdit *urledit;
};

class RecvAuth : public RecvDetail {
  Q_OBJECT
public:
  RecvAuth(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void authorizeRequest();
  void declineRequest();
private:
  QMultiLineEdit *msgedit;
};

class RecvChatReq : public RecvDetail {
  Q_OBJECT
public:
  RecvChatReq(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void acceptRequest();
  void declineRequest();
private:
  QMultiLineEdit *msgedit;
};

class RecvFileReq : public RecvDetail {
  Q_OBJECT
public:
  RecvFileReq(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void saveRequest();
  void saveAsRequest();
  void declineRequest();
private:
  QMultiLineEdit *msgedit;
};

class RecvAdded : public RecvDetail {
  Q_OBJECT
public:
  RecvAdded(icqMessage *msg, QWidget *parent = 0);
protected slots:
  void replyRequest();
};

class RecvWindow : public IcqWindow {
  Q_OBJECT
public:
  RecvWindow(QList<icqMessage>*, int, unsigned long, bool d = TRUE);
  ~RecvWindow();
  void setUIN(unsigned long);
  void setName(const QString &);
  void setEMail(const QString &);
  void setTime(TimeStr);
  unsigned long UIN(){ return msgUin; };
  void updateNextAvailability();
  void makeWindow(icqMessage *msg);
public slots:
  void closeBtn();
signals:
protected:
  QPixmap px_stat;
  QString recvCaption;
  QList<icqMessage> *list;
  int start, idx;
  bool delflag;
  unsigned long msgUin;
  QString nick;
  QString email;
  QLabel *uinlabel, *handlelabel, *emaillabel, *datelabel, *timelabel, *statuslabel;
  QLineEdit *uinline, *handleline, *emailline, *dateline, *timeline;
  QPushButton *nextbtn, *infobutton;
  QGroupBox *frombox;
  QWidgetStack *detail;
  QHBoxLayout* hbox;
  QVBoxLayout* vbox;
  QGridLayout* grid;
  void readsize();
  void closeEvent(QCloseEvent *);
protected slots:
  void infoRequest();
  void readNext();
  void savesize();
private:
private slots:
};
#endif
