/***************************************************************************
    description          : mydetailsmain.cpp
    begin                : Thu Sep 14 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qbuttongroup.h>
#include "mydetails.h"
#include "mydetailsmain.h"
#include "mainwindow.h"
#include "mydetailspics.h"
#include "corewidget.h"

#include "mydetailsmain.moc"


MyMainWidget::MyMainWidget(QWidget *parent) : QWidget(parent)
{

  QButtonGroup *icqbox = new QButtonGroup(this);
  icqbox->setGeometry(2, 6, 404, 48);
  icqbox-> setFrameStyle(QFrame::Box | QFrame::Sunken);
  icqbox->setTitle(i18n("ICQ Number"));

  QLabel *icon = new QLabel(icqbox);
  icon->setGeometry(10, 20, 16, 16);
  icon->setFrameStyle(QFrame::NoFrame);
  icon->setPixmap(QPixmap(uin_xpm));
  icon->setAlignment(AlignHCenter | AlignVCenter);

  QLabel *uinlabel = new QLabel(i18n("ICQ#:"),icqbox);
  uinlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  uinlabel->setGeometry(36, 18, 42, 20);
  uinlabel->setAlignment(AlignHCenter | AlignVCenter);
  uinlabel->setFrameStyle(QFrame::NoFrame);

  uinline = new ULine(icqbox,true);
  uinline->setGeometry(84, 18, 110, 20);
  uinline->setAlignment(Qt::AlignHCenter);
  uinline->setFocusPolicy(QWidget::NoFocus);

////////////////////////////////////////////////////////////////////////////////////////////////////////////
  QButtonGroup *namebox = new QButtonGroup(this);
  namebox->setGeometry(2, 55, 404, 78);
  namebox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  namebox->setTitle(i18n("Name"));

  QLabel *firstlabel = new QLabel(i18n("First Name:"),namebox);
  firstlabel->setGeometry(10, 18, 70, 20);
  firstlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  firstlabel->setFrameStyle(QFrame::NoFrame);
  firstlabel->setAlignment(AlignLeft | AlignVCenter);

  firstline = new QLineEdit(namebox);
  firstline->setGeometry(84, 18, 110, 20);

  QLabel *lastlabel = new QLabel(i18n("Last Name:"),namebox);
  lastlabel->setGeometry(202, 18, 70, 20);
  lastlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));

  lastline = new QLineEdit(namebox);
  lastline->setGeometry(276, 18, 115, 20);

  QLabel *nicklabel = new QLabel(i18n("Nickname:"),namebox);
  nicklabel->setGeometry(10, 48, 70, 19);
  nicklabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  nicklabel->setFrameStyle(QFrame::NoFrame);
  nicklabel->setAlignment(AlignLeft | AlignVCenter);

  nickline = new QLineEdit(namebox);
  nickline->setGeometry(84, 48, 110, 20);


 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  QButtonGroup *emailbox = new QButtonGroup(this);
  emailbox->setGeometry(2, 136, 404, 114);
  emailbox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  emailbox->setTitle(i18n("Email Addresses"));

  emailline = new QLineEdit(emailbox);
  emailline->setGeometry(10, 18, 271, 20);

  addbut = new QPushButton(emailbox);
  addbut->setGeometry(295, 16, 95, 20);
  addbut->setText(i18n("Add"));

  editbut = new QPushButton(emailbox);
  editbut->setGeometry(295, 38, 95, 20);
  editbut->setText(i18n("Edit"));

  rembut = new QPushButton(emailbox);
  rembut->setGeometry(295, 61, 95, 20);
  rembut->setText(i18n("Remove"));

  setbut = new QPushButton(emailbox);
  setbut->setGeometry(295, 84, 95, 20);
  setbut->setText(i18n("Set as Default"));


}

MyMainWidget::~MyMainWidget()
{

}

void MyMainWidget::setMyUIN(const QString &text, const QString &nick)
{
   uinline->setText(text);
   nickline->setText(nick);
}
void MyMainWidget::setMyNames(const QString &first, const QString &last)
{
  firstline->setText(first);
  lastline->setText(last);
}
