/***************************************************************************
    description          : pref_conn.h
    begin                : Tue Apr 25 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREF_CONN_H
#define PREF_CONN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlabel.h>
#include <qlined.h>
#include <qcombobox.h>
#include <qgrpbox.h>
#include <qtabwidget.h>
#include <qcheckbox.h>
#include "corewidget.h"

class UserWidget : public QWidget {
  Q_OBJECT
public:
  UserWidget(QWidget *);
  void setInfo(unsigned long, const QString &, const QString &);
  unsigned long uin()  { return uinline->value(); };
  const QString nick() { return nickline->text(); };
  const QString pass() { return passline->text(); };
public slots:
signals:
protected:
  KIntegerLine *uinline;
  QLineEdit *nickline, *passline;
protected slots:
private:
private slots:
};

class ServerWidget : public QWidget {
  Q_OBJECT
public:
  ServerWidget(QWidget *);
  void setInfo(const QString &, int);
  const QString host()  { return hostline->currentText(); };
  unsigned short port() { return portline->value(); };
public slots:
signals:
protected:
  QComboBox *hostline;
  KIntegerLine *portline;
protected slots:
private:
private slots:
};

class ProxyWidget : public QWidget {
  Q_OBJECT
public:
  ProxyWidget(QWidget *);
  void setInfo(int, const QString &, int, int, const QString &, const QString &);
  int use() { return usebox->isChecked(); };
  const QString host() { return hostline->text(); };
  int port() { return portline->value(); };
  int auth() { return authbox->isChecked(); };
  const QString user() { return userline->text(); };
  const QString pass() { return passline->text(); };
public slots:
signals:
protected:
  QLineEdit *hostline, *userline, *passline;
  KIntegerLine *portline;
  QCheckBox *usebox, *authbox;
protected slots:
  void useToggled(bool);
  void authToggled(bool);
private:
private slots:
};

class ConnTab : public QTabWidget {
    Q_OBJECT

public:
    ConnTab(QWidget *parent = NULL, const char *name = NULL);

protected:
     UserWidget *user;
     ServerWidget *server;
     ProxyWidget *proxy;
};

class Connections : public QWidget {
    Q_OBJECT

public:
    Connections(QWidget *parent = NULL, const char *name = NULL);
    ConnTab *conntab;
protected:
};
#endif
