/***************************************************************************
    description          : pref_events.h
    begin                : Tue Apr 25 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREF_EVENTS_H
#define PREF_EVENTS_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlabel.h>
#include <qlined.h>
#include <qcombobox.h>
#include <qgrpbox.h>
#include <qtabwidget.h>
#include <qcheckbox.h>
#include <qchkbox.h>
#include <qgrpbox.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <kaudioplayer.h>
#include "corewidget.h"

///////////////////////////////////////////////////////////////////////////
class SoundWidget : public QWidget {
  Q_OBJECT
public:
  SoundWidget(QWidget *);
  void setInfo(int);
  int wav();
  QString soundpath;
public slots:
signals:
protected:
  KAudioPlayer *audio;
  QCheckBox *bellbox, *wavbox, *userbox;
  QListBox *soundlist, *eventlist;
  QPushButton *testbutton;
protected slots:
  void soundSelected(int);
  void eventSelected(int);
  void testClicked();
private:
private slots:
};
/////////////////////////////////////////////////////////////////////////
class LoggingWidget : public QWidget {
  Q_OBJECT
public:
  LoggingWidget(QWidget *);
  void setInfo(int, const QString &);
  int level()             { return levelbox->currentItem(); };
  const QString logfile() { return logline->text(); };
public slots:
signals:
protected:
  QComboBox *levelbox;
  QLineEdit *logline;
protected slots:
private:
private slots:
};
//////////////////////////////////////////////////////////////////////////
class BrowserPrefWidget : public QWidget {
  Q_OBJECT
public:
  BrowserPrefWidget(QWidget *);
  void save();
public slots:
signals:
protected:
  QComboBox *browserbox;
protected slots:
private:
private slots:
};
//////////////////////////////////////////////////////////////////////////
class EventsTab : public QTabWidget {
    Q_OBJECT

public:
    EventsTab(QWidget *parent = NULL, const char *name = NULL);

protected:

};

class Events : public QWidget {
    Q_OBJECT

public:
    Events(QWidget *parent = NULL, const char *name = NULL);
    EventsTab *evtab;
protected:
};
#endif
