/***************************************************************************
                          kwebbrowser.cpp  -  description                       
                             -------------------                                
    begin                : Tue Aug 31 1999                                      
    copyright            : (C) 1999 by Markus Goetz                         
    email                : guruz@gmx.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "kwebbrowser.h"
#include <stdlib.h>
#include <unistd.h>
#include <qclipboard.h>
#include <ksimpleconfig.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qdir.h>
#include <kprocess.h>
#include "mainwindow.h"
#include "uconfigdb.h"
#include "kwebbrowser.moc"

KWebBrowser::KWebBrowser(void)
{
  return;
}

KWebBrowser::~KWebBrowser(void)
{
  return;
}

void KWebBrowser::callWebBrowser(QString URL)
{
  QString stringbrowser;
  int browser = getBrowser(); 

  if (URL.left(7) == "mailto:")
    browser = BROWSER_KFM;

  switch (browser)
  {
    case BROWSER_KFM:
      execBrowser("kfmclient openURL %s", URL);
      stringbrowser = "Konqueror";
      break;
    case BROWSER_CLIPBOARD:
      kapp->clipboard()->setText(URL);
      stringbrowser = "Clipboard";
      break;
    case BROWSER_NETSCAPE:
      {
        QString homedir = getenv("HOME");
        QString lockfile = QString(homedir + "/.netscape/lock");
        if (system(QString("test -L " + lockfile).latin1()) == 0)
          execBrowser("netscape -remote 'openURL(%s,new-window)'", URL);
        else
          execBrowser("netscape %s", URL);
        sleep(2);
        stringbrowser = "Netscape";
        break;
      }
    case BROWSER_NETSCAPE_NSS:
      execBrowser("netscape %s", URL);
      stringbrowser = "Netscape";
      break;
    case BROWSER_LYNX:
      execBrowser("konsole -e lynx %s", URL);
      stringbrowser = "Lynx";
      break;
    case BROWSER_WGET:
      execBrowser("konsole -e wget %s", URL);
      stringbrowser = "Wget";
      break;
  };
  return;
}

void KWebBrowser::execBrowser(QString const &cmd, QString const &URL)
{
       // First of all, make sure the URL won't do anything harmful.
       if (URL.left(1) == "-") // Think "-display some.other.host:0"
               return;

       QStringList args=QStringList::split(" ", cmd, false);
       KProcess proc;
       for(QStringList::ConstIterator it=args.begin(); it!=args.end(); it++) {
               if((*it).contains("%s")) {
                       QString arg=(*it);
                       arg.replace(QRegExp("%s"), URL);
                       proc << arg;
               } else
                       proc << *it;
       }
       proc.start(KProcess::DontCare);
}

void KWebBrowser::setBrowser(int id)
{
  db->setPath(MW->getOwnerPath() + "/Preferences/Events/WebBrowser");
  db->writeEntry("browser", id);
  return;
}

int KWebBrowser::getBrowser(void)
{
  db->setPath(MW->getOwnerPath() + "/Preferences/Events/WebBrowser");
  int id = db->readEntry("browser").toInt();
  return id;
}
